#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include "PatronES.h"

using namespace std;
const short NUMVAR = 2;
const short NUMTOTAL = NUMVAR* 2 + 1;


/*************************************************************************/
// Procedimiento que con los datos de la topologa genera los patrones necesarios
// para la misma, pidiendo el nmero total de patrone sy elnombre del fichero
void creapatronesES (vector <unsigned> entrada, vector <unsigned> salida, string nombre) {
  cout << endl << "Escriba el nmero total de patrones: ";
  unsigned numpatrones;
  cin >> numpatrones;  
  for (int i = 0; i <= NUMVAR; i++) {
    if (entrada[i] == 0)
      entrada[i] = 1;
    if (salida[i] == 0)
      salida[i] = 1;    
  }  // eliminar los ceros para poder multiplicar para todos los casos
  entrada.push_back (entrada[0] * entrada[1]);
  salida.push_back (salida[0] * salida[1]);
  // Preparamos el fichero de salida
  fstream fich;
  if (nombre == "") {
    cout << "Escriba el nombre del fichero donde guardar los patrones: ";  
    cin >> nombre;
  }  
  fich.open (nombre.c_str (), ios::out);  
  if (!fich.good ()) {
    cout << "El fichero " << nombre << " no ha podido ser abierto" << endl;
    exit (1);
  }
  system ("cls");                                           // cambiarlo para otro sistema operativo
//  system ("clear");     
  PatronES primero (entrada, salida, 1, true);
  fich << primero;                                          // el primero no est en el for para poder informar al usuario cmo usar los patrones
  for (int i = 1; i < numpatrones; i++) {
    PatronES resto (entrada, salida, i+1);
    fich << resto;
  }  
  fich.close();
  cout << "El fichero ha sido creado con xito." << endl; 
}


/*************************************************************************/
// Procedimientoo principal :P
int main(int argc, char *argv[]) {
  // presentacin
  cout << "******************************************************************************" << endl
       << "**--------------------------------------------------------------------------**" << endl
       << "**Programa para generar ficheros de patrones de entrada/salida para el SNNS.**" << endl
       << "**--------------------------------------------------------------------------**" << endl
       << "******************************************************************************" << endl
       << endl << endl;
  // eleccin de la forma
  vector <unsigned> entrada, salida;
  unsigned temp = 0;
  string nombrefich = "";
  switch (argc) {
    case 1: {cout << "Este programa tambin permite recibir los parmetros en linea de comandos." << endl
                  << "Para ello use la siguiente sintaxis:\n\"nombre del programa\" \"neuronas XY de entrada\" \"neuronas XY de salida\"\n\"Nombre del fichero de salida\n" << endl
                  << endl << "Ejemplo: " << argv[0] << " 1 3 6 8 prueba.pat" << endl << endl << endl;
             cout << "Indique la topologa de su red." << endl << endl;             
             for (int j = 1; j <= NUMVAR; j++) {
               cout << "Topologa de ";
               if (j == 1)
                 cout << "ENTRADA:" << endl;
               else
                 cout << "SALIDA:" << endl;
               for (int i = 1; i <= NUMVAR; i++) {
                 cout << "Escriba el nmero de neuronas en el eje";
                 switch (i) {
                   case 1: cout << " X: "; break;
                   case 2: cout << " Y: "; break;                   
                 }
                 cin >> temp;
                 if (j == 1)
                   entrada.push_back (temp);
                 else
                   salida.push_back (temp);
               } // para cada eje de coordenadas
             } // para entrada y salida
             creapatronesES (entrada, salida, nombrefich);
            } break; // si se ejecuta sin parmetros
    case 8: {
             for (int i = 1; i <= NUMVAR; i++) {
               temp = atoi (argv[i]);
               entrada.push_back (temp);
               temp = atoi (argv[i + NUMVAR]);
               salida.push_back (temp);
             }
             nombrefich = argv[NUMTOTAL];
             creapatronesES (entrada, salida, nombrefich);
            } break; // si se ejecuta con los parmetros adecuados
    default: cout << "Para usar correctamente el programa invquelo sin parmetros o con los parme-\ntros adecuados." << endl
                  << "Para ello use la siguiente sintaxis:\n\"nombre del programa\" \"neuronas XYZ de entrada\" \"neuronas XYZ de salida\"\n\"Nombre del fichero de salida\n" << endl
                  << endl << "Ejemplo: " << argv[0] << " 1 3 6 8 prueba.pat";
                  // si se ejecuta de cualquier otra forma            
  }  
  return 0;
}
