/*********************************************
* Nombre: Clase rango
* Copyright: PTK
* Autor: Aitor Hernndez Hernndez Alu2648
* Fecha de realizacin: 29 de octubre del 2005
* Descripcin: Archivo cabecera de la clase rango.
* Se usa para guardar un valor concreto o un rango
* para generar nmeros aleatorios dentro del mismo
*********************************************/

#include "Rango.h"


/*************************************************************************/
// Constructor de la clase rango
Rango::Rango () { 
  inferior = superior = 0;  
}  


/*************************************************************************/
// Constructor de la clase rango que inicializa los valores
Rango::Rango (const int inf, const int sup) { 
  setnums (inf, sup);
}  


/*************************************************************************/
// Metodo que rellena los atributos conlso valores de la entrada
void Rango::setnums (const int inf, const int sup){ 
  inferior = inf;
  superior = sup;  
}  


/*************************************************************************/
// Metodo que devuelve un nmero real en el rango inferior superior
double Rango::getnum (void) {
  srand (rand());                 // semilla aleatoria aleatoria
  double temp = rand ();         // No se une con la siguiente porque da siempre cero
  temp = temp / RAND_MAX;       // generacin de un nmero entre cero y uno
  return (inferior + (superior - inferior) * temp);
}


/*************************************************************************/
// Metodo que muestra los valores insertados como extremos
ostream& Rango::mostrar (ostream &sout) {
  sout << "Inferior: " << inferior << endl;
  sout << "Superior: " << superior << endl;
  sout << "Valor del rango: " << getnum () << endl;
  return (sout);
}  


//**********************************
// sobrecarga de operadores externos
//**********************************

/*************************************************************************/
// sobrecarga para mostrar un fichero completo
// no es constante porque mostrar un fichero lo modificas necesariamente
ostream& operator << (ostream &sout, Rango &rango) {
  return (rango.mostrar (sout));
}  

